=== debian/changelog ===
ros-kinetic-eigenpy (2.5.0-1xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Justin Carpentier <justin.carpentier@inria.fr>  Wed, 26 Aug 2020 09:43:30 -0000
